/********************************************************
 * 	eBOOKLEARNING - 
 *	E-book-based interactive learning system
 * ======================================================
 *
 * License: http://www.gnu.org/licenses/gpl.html
 * @author Florence Adegeye
 * @version: 1.0, 2015/01/31
 *
 ********************************************************/
package at.tuwien.ebooklearning.dictionary;

import android.util.Log;
import at.tuwien.ebooklearning.webservices.GlosbeJSONService;
import at.tuwien.ebooklearning.webservices.GoogleJSONService;
import at.tuwien.ebooklearning.webservices.IDictionaryResult;

public class DictionaryHandler{
	
	private DictionaryLanguages language;
	private DictionaryWebServices webservice;
	private IDictionaryResult dictResult;
	
	public DictionaryHandler(DictionaryLanguages language, DictionaryWebServices webservice,IDictionaryResult dictResult) {
		super();
		this.language = language;
		this.webservice = webservice;
		this.dictResult = dictResult;
	}

	//todo constructor mit service auswahl
	public void lookupWord(String word){
		
		if(webservice == DictionaryWebServices.GLOSBE){	
			GlosbeJSONService glosbeDict = 	new GlosbeJSONService(this.dictResult);
			
			if(language == DictionaryLanguages.DEtoEN){
				glosbeDict.execute("deu","eng",word);
				
			}else if(language == DictionaryLanguages.ENtoDE){
				glosbeDict.execute("eng","deu",word);
			}else{
				Log.i( DictionaryHandler.class.getName(),"Language not supported!");
			}
		
		}else if(webservice == DictionaryWebServices.GOOGLE_TRANSLATE){

			GoogleJSONService googleDict = 	new GoogleJSONService(this.dictResult);
			

			if(language == DictionaryLanguages.DEtoEN){
				googleDict.execute("de","en",word);
				
			}else if(language == DictionaryLanguages.ENtoDE){
				googleDict.execute("en","de",word);
			}else{
				Log.i( DictionaryHandler.class.getName(),"Language not supported!");
			}
			
			
		}else{
			Log.i(DictionaryHandler.class.getName(),"Unknown Webservice");
		}
		
	}
	
	/*@Override
	public void onDictionaryCompleted(DictionaryEntry result) {
		
		if(result != null){
			this.dictResult = result;
		}
		
		String verb = "";
		int verbLength = 0;
		if(result.getVerb() != null){
			verb = result.getVerb()[0];
			verbLength = result.getVerb().length;
		}
		String sub = "";
		int subLength = 0;
		if(result.getSubstantiv() != null){
			sub = result.getSubstantiv()[0];
			subLength = result.getSubstantiv().length;
		}
		String verbSyn = "";
		int verbSynLength = 0;
		if(result.getSynonyms_verb() != null){
			verbSyn = result.getSynonyms_verb()[0];
			verbSynLength = result.getSynonyms_verb().length;
		}
		String subSyn = "";
		int subSynLength = 0;
		if(result.getSynonyms_substantiv() != null){
			subSyn = result.getSynonyms_substantiv()[0];
			subSynLength = result.getSynonyms_substantiv().length;
		}
		String subEx = "";
		
		if(result.getExplanation_substantiv() != null){
			subEx = result.getExplanation_substantiv();
			
		}
		String verbEx = "";
		
		if(result.getExplanation_verb() != null){
			verbEx = result.getExplanation_verb();
			
		}
		String ex = "";
		int exLength = 0;
		if(result.getExamples() != null){
			ex = result.getExamples()[0];
			exLength = result.getExamples().length;
		}
		
		String trans = "";
		
		if(result.getTranslation() != null){
			trans = result.getTranslation();
			
		}
		
		HashMap<String,String> synDes = null;
		String sd = "";
		if(result.getSynonymsDescription() != null){
			synDes = result.getSynonymsDescription();
			Iterator it = synDes.entrySet().iterator();
			while (it.hasNext()) {
			        Map.Entry pairs = (Map.Entry)it.next();
			        sd += " | "+ pairs.getKey() + " = " + pairs.getValue();
			        it.remove(); // avoids a ConcurrentModificationException
			}
			
			
		}
		
		// TODO Auto-generated method stub
		Log.i(DictionaryHandler.class.getName(), trans + "\n Substanitive:" + sub+" - "+ subLength
				 + "\n Verb:" + verb +" - "+ verbLength 
				 + "\n SubSyn: " + subSyn+" - "+ subSynLength
				 + "\n VerbSyn:" + verbSyn +" - "+ verbSynLength
				 + "\n ExplSub: " + subEx
				 + "\n ExplVerb: " + verbEx
				 + "\n Eg.: " + ex +" - "+ exLength
				 +"\n synDes: " + sd);
	}*/

	/**
	 * @param language the language to set
	 */
	public void setLanguage(DictionaryLanguages language) {
		this.language = language;
	}

	/**
	 * @param webservice the webservice to set
	 */
	public void setWebservice(DictionaryWebServices webservice) {
		this.webservice = webservice;
	}

	/**
	 * @return the language
	 */
	public DictionaryLanguages getLanguage() {
		return language;
	}

	/**
	 * @return the webservice
	 */
	public DictionaryWebServices getWebservice() {
		return webservice;
	}

	
	
}
