/********************************************************
 * 	eBOOKLEARNING - 
 *	E-book-based interactive learning system
 * ======================================================
 *
 * License: http://www.gnu.org/licenses/gpl.html
 * @author Florence Adegeye
 * @version: 1.0, 2015/01/31
 *
 ********************************************************/
package at.tuwien.ebooklearning.ebookservices;

import java.io.File;
import java.util.Date;
import java.util.List;

import nl.siegmann.epublib.domain.Author;
import nl.siegmann.epublib.domain.Book;

public class BookInfo{
	
	private String title;
	private String author;
	private String language;
	
	private String shortInfo;
	private Date lastOpened;
	private String filepath;
	
	private Book epub;
	private File bookfile;
	private long filesize;
	private String filename;
	private int bookid;
	
	public BookInfo() {
		super();
		// TODO Auto-generated constructor stub
	}


	
	
	/**
	 * @return the epub
	 */
	public Book getEpub() {
		return epub;
	}




	/**
	 * @param epub the epub to set
	 */
	public void setEpub(Book epub) {
		this.epub = epub;
	}




	/**
	 * @return the bookfile
	 */
	public File getBookfile() {
		return bookfile;
	}




	/**
	 * @param bookfile the bookfile to set
	 */
	public void setBookfile(File bookfile) {
		this.bookfile = bookfile;
	}




	/**
	 * @return the filesize
	 */
	public long getFilesize() {
		return filesize;
	}




	/**
	 * @param size the filesize to set
	 */
	public void setFilesize(long size) {
		this.filesize = size;
	}




	/**
	 * @return the bookid
	 */
	public int getBookid() {
		return bookid;
	}




	/**
	 * @param bookid the bookid to set
	 */
	public void setBookid(int bookid) {
		this.bookid = bookid;
	}




	/**
	 * @return the title
	 */
	public String getTitle() {
		return title;
	}


	/**
	 * @param title the title to set
	 */
	public void setTitle(String title) {
		this.title = title;
	}


	/**
	 * @return the author
	 */
	public String getAuthor() {
		return author;
	}


	/**
	 * @param author the author to set
	 */
	public void setAuthor(String author) {
		this.author = author;
	}


	/**
	 * @return the language
	 */
	public String getLanguage() {
		return language;
	}


	/**
	 * @param language the language to set
	 */
	public void setLanguage(String language) {
		this.language = language;
	}


	/**
	 * @return the filename
	 */
	public String getFilename() {
		return filename;
	}


	/**
	 * @param filename the filename to set
	 */
	public void setFilename(String filename) {
		this.filename = filename;
	}


	/**
	 * @return the shortInfo
	 */
	public String getShortInfo() {
		return shortInfo;
	}


	/**
	 * @param shortInfo the shortInfo to set
	 */
	public void setShortInfo(String title, List<Author> author) {
		
		String allAuthors = "";
		
		for (Author currentAuthor : author) {
			allAuthors += " "+currentAuthor;
		}
		
		
		this.shortInfo = title + "-" + allAuthors;
	}


	/**
	 * @return the lastOpened
	 */
	public Date getLastOpened() {
		return lastOpened;
	}


	/**
	 * @param lastOpened the lastOpened to set
	 */
	public void setLastOpened(Date lastOpened) {
		this.lastOpened = lastOpened;
	}


	/**
	 * @return the filepath
	 */
	public String getFilepath() {
		return filepath;
	}


	/**
	 * @param filepath the filepath to set
	 */
	public void setFilepath(String filepath) {
		this.filepath = filepath;
	}



	

}
