/********************************************************
 * 	eBOOKLEARNING - 
 *	E-book-based interactive learning system
 * ======================================================
 *
 * License: http://www.gnu.org/licenses/gpl.html
 * @author Florence Adegeye
 * @version: 1.0, 2015/01/31
 *
 ********************************************************/
package at.tuwien.ebooklearning.ebookservices;

import java.io.File;
import java.util.HashMap;

import android.annotation.SuppressLint;
import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.util.Log;

@SuppressLint("UseSparseArrays")
public class BookLoaderService extends Service {
	
	private boolean booksloaded = false;
	private HashMap<Integer, BookInfo> bookcollection;
	private int bookID = 0;
	
	/* (non-Javadoc)
	 * @see android.app.Service#onCreate()
	 */
	@Override
	public void onCreate() {
		// TODO Auto-generated method stub
		super.onCreate();
		bookcollection = new HashMap<Integer, BookInfo>();
	}

	@Override
	public IBinder onBind(Intent intent) {
		return null;
	}

	/* (non-Javadoc)
	 * @see android.app.Service#onStartCommand(android.content.Intent, int, int)
	 */
	@Override
	public int onStartCommand(final Intent intent, int flags, int startId) {
		
		Thread loadingT = new Thread(new Runnable() {
			
			@Override
			public void run() {
				// TODO Auto-generated method stub
				Log.i("BookLoaderService", "BookloaderService started!");
				String [] searchValues = intent.getStringArrayExtra("searchValues");
					
				booksloaded = loadEPubs(searchValues[0], searchValues[1]);

				BooksManager.savebooks(bookcollection);
				
				//send finished notification to startactivity
				Intent loaderNotification = new Intent();
				loaderNotification.setAction("BookLoadingBroadcast");
				loaderNotification.putExtra("loaded", booksloaded);
					
				sendBroadcast(loaderNotification);
				
			}
		});
		loadingT.start();
		return START_STICKY;
	}

	/* (non-Javadoc)
	 * @see android.app.Service#onDestroy()
	 */
	@Override
	public void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		//clear list
		bookcollection.clear();
		Log.i("BookLoaderService", "BookloaderService stopped!");
	}

	
	private boolean loadEPubs(String path, String extension){
		
		
		File bookfiles = new File(path);
		
		Log.e("path", "f: " + bookfiles);
		if(!bookfiles.isDirectory()){
			Log.e("loadEPub", "Directory does not exist");
			return false;
		}else{
			
			File[] filelist =  bookfiles.listFiles();
			Log.i("file","filepath: "+ bookfiles.listFiles());
			if(filelist != null){
				if(filelist.length != 0){
					
					for (File file : filelist) {
						
						if(file.isFile() && file.getName().endsWith(extension)){
							BookInfo currentBookInfo = BooksManager.createBookInfo(file);
							currentBookInfo.setBookid(bookID);
							bookcollection.put(bookID, currentBookInfo);	
							bookID++;
							
							
						}else if(file.isDirectory()){
							
							loadEPubs(file.getAbsolutePath(), extension);
							
						}
					}
					
					return true; 
				}else{
					//show text to import files
					
					Log.e("loadePubs", "No files imported");
					
				}	
			}else{
				Log.e("loadedPubs", "Filelist error");
			}
			
			return false;
			
		}
	
	}
	
	/*private BookInfo createBookInfo(File file){
		BookInfo myBook = new BookInfo();
		
		//create epub
		InputStream epubInputStream;
		try {
			epubInputStream = new BufferedInputStream(new FileInputStream(file));
			
			if(epubInputStream != null){
				 Book book = (new EpubReader()).readEpub(epubInputStream);
				 myBook.setEpub(book);
				 myBook.setTitle(book.getTitle());
				 myBook.setShortInfo(book.getTitle(), book.getMetadata().getAuthors());
				 
				 myBook.setBookfile(file);
				 myBook.setFilename(file.getName());
				 myBook.setFilepath(file.getAbsolutePath());
				 myBook.setFilesize(file.length());
			 }
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
		 
		return myBook;
	}*/
	
	
	
}
