/********************************************************
 * 	eBOOKLEARNING - 
 *	E-book-based interactive learning system
 * ======================================================
 *
 * License: http://www.gnu.org/licenses/gpl.html
 * @author Florence Adegeye
 * @version: 1.0, 2015/01/31
 *
 ********************************************************/
package at.tuwien.ebooklearning.ebookservices;

import java.util.List;
import android.annotation.SuppressLint;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;
import at.tuwien.ebooklearning.R;


@SuppressLint("InflateParams")
public class CustomAdapter extends ArrayAdapter<TOCData>{

	private LayoutInflater inflater;
	
    public CustomAdapter(Context context, int resource,
            int textViewResourceId, List<TOCData> objects) {
        super(context, resource, textViewResourceId, objects);
        inflater = (LayoutInflater) getContext().getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    }

    private class ViewHolder{
        private View row;
        private TextView titleHolder = null;

        public ViewHolder(View row) {
            super();
            this.row = row;
        }

        public TextView getTitle() {
            if(null == titleHolder)
               titleHolder = (TextView) row.findViewById(R.id.toc);
            return titleHolder;
        }
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder = null;
        TextView title = null;
        
        TOCData rowData = getItem(position);
        if(null == convertView){
            convertView = inflater.inflate(R.layout.activity_book_overview, null);
            holder = new ViewHolder(convertView);
            convertView.setTag(holder);
        }
        holder = (ViewHolder) convertView.getTag();
        title = holder.getTitle();
        title.setText(rowData.getTitle());
        return convertView;
    }
    
}
