/********************************************************
 * 	eBOOKLEARNING - 
 *	E-book-based interactive learning system
 * ======================================================
 *
 * License: http://www.gnu.org/licenses/gpl.html
 * @author Florence Adegeye
 * @version: 1.0, 2015/01/31
 *
 ********************************************************/
package at.tuwien.ebooklearning.views;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import nl.siegmann.epublib.domain.TOCReference;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;
import at.tuwien.ebooklearning.R;
import at.tuwien.ebooklearning.ebookservices.BookInfo;
import at.tuwien.ebooklearning.ebookservices.BooksManager;
import at.tuwien.ebooklearning.ebookservices.CustomAdapter;
import at.tuwien.ebooklearning.ebookservices.TOCData;

public class BookToCActivity extends Activity {

	private BookInfo currentBook;
	private List<TOCData> tocDetails;
	private ListView tocView;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_book_overview);
		tocView = (ListView)findViewById(R.id.tocView);
		tocDetails = new ArrayList<TOCData>();
		currentBook= BooksManager.getCurrentBook();
		
		createToC(currentBook.getEpub().getTableOfContents().getTocReferences(), 0);
		
		CustomAdapter tocAdapter = new CustomAdapter(this,android.R.layout.simple_list_item_1, R.id.toc,tocDetails);
		tocView.setAdapter(tocAdapter);
		tocView.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> parent, View view,
					int position, long id) {
				// TODO Auto-generated method stub
				   TOCData rowData = tocDetails.get(position);
				    Intent intent = new Intent(getApplicationContext(), ContentActivity.class);
				  
				    try {
						intent.putExtra("chapter", new String(rowData.getResource().getData()));
						
						 startActivity(intent);
					} catch (OutOfMemoryError e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
			}
		});
		
	}
	
	private void createToC(List <TOCReference> tocRefList, int depth){
		if (tocRefList != null){
			for (TOCReference tocReference:tocRefList) {
		        StringBuilder tocString = new StringBuilder();
		        for (int i = 0; i < depth; i++) {
		            tocString.append("\t");
		        }
		        tocString.append(tocReference.getTitle());
		        TOCData toc = new TOCData();
		        toc.setResource(tocReference.getResource());
		        toc.setTitle(tocString.toString());
		        tocDetails.add(toc);   
		        createToC(tocReference.getChildren(), depth+1);
		      
		    }
			
		}else{
			return;
		}
	}
	
	
}


