/********************************************************
 * 	eBOOKLEARNING - 
 *	E-book-based interactive learning system
 * ======================================================
 *
 * License: http://www.gnu.org/licenses/gpl.html
 * @author Florence Adegeye
 * @version: 1.0, 2015/01/31
 *
 ********************************************************/
package at.tuwien.ebooklearning.views;

import java.io.File;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import at.tuwien.ebooklearning.R;
import at.tuwien.ebooklearning.ebookservices.BookLoaderService;
import at.tuwien.ebooklearning.ebookservices.BooksManager;
import at.tuwien.ebooklearning.utils.eBookLearningConstants;

public class StartActivity extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
		
        //create or read from /files/
        File myBooksDir = getApplicationContext().getFilesDir();
        
       //search and load epubs 
        Intent bookintent = new Intent(getApplicationContext(), BookLoaderService.class);
        String [] searchValues = {myBooksDir.getAbsolutePath(), eBookLearningConstants.EBOOK_FILE_EXT}; 
        bookintent.putExtra("searchValues", searchValues);
        startService(bookintent);
       
      
		
	}

	/* (non-Javadoc)
	 * @see android.app.Activity#onDestroy()
	 */
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		BooksManager.loadbooks().clear();
		super.onDestroy();
	}

	/* (non-Javadoc)
	 * @see android.app.Activity#onRestart()
	 */
	@Override
	protected void onRestart() {
		// TODO Auto-generated method stub
		BooksManager.loadbooks().clear();
		super.onRestart();
	}
	
	
	
	
}
