/********************************************************
 * 	eBOOKLEARNING - 
 *	E-book-based interactive learning system
 * ======================================================
 *
 * License: http://www.gnu.org/licenses/gpl.html
 * @author Florence Adegeye
 * @version: 1.0, 2015/01/31
 *
 ********************************************************/
package at.tuwien.ebooklearning.webservices;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.os.AsyncTask;
import android.util.Log;
import at.tuwien.ebooklearning.utils.eBookLearningConstants;

public class WikiJSONTestService extends AsyncTask<String, Void, String>{

	
	private JSONObject createJSON(String input){
		JSONObject wikiResponse = null;
		try {
			
			 wikiResponse = new JSONObject(input);
	         JSONObject query = wikiResponse.getJSONObject(eBookLearningConstants.W_QUERY);
	            JSONObject pages = query.getJSONObject(eBookLearningConstants.W_PAGES);
	            JSONObject page = pages.getJSONObject((String) pages.keys().next());
	            JSONArray revisions = page.getJSONArray(eBookLearningConstants.W_REVISIONS);
	            JSONObject revision = revisions.getJSONObject(0);
	         
			Log.i("jsonresult",  revision.getString(eBookLearningConstants.W_ALL));
			return wikiResponse;
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return wikiResponse;
	}
	
	private String openWikionary(String text) {
		    StringBuilder builder = new StringBuilder();
		    HttpClient client = new DefaultHttpClient();
		    HttpGet httpGet = new HttpGet(eBookLearningConstants.WIKTIONARY_URL+text);
		    try {
		      HttpResponse response = client.execute(httpGet);
		      StatusLine statusLine = response.getStatusLine();
		      int statusCode = statusLine.getStatusCode();
		      if (statusCode == 200) {
		        HttpEntity entity = response.getEntity();
		        InputStream content = entity.getContent();
		        BufferedReader reader = new BufferedReader(new InputStreamReader(content));
		        String line;
		        while ((line = reader.readLine()) != null) {
		          builder.append(line);
		        }
		      } else {
		        Log.e("parsejson", "Failed to connect to Wiktionary");
		      }
		    } catch (ClientProtocolException e) {
		      e.printStackTrace();
		    } catch (IOException e) {
		      e.printStackTrace();
		    }
		    return builder.toString();
	}

	@Override
	protected String doInBackground(String... inputs) {
		// TODO Auto-generated method stub
		String text = inputs[0];
		String wikiresult = openWikionary(text);
		return wikiresult;
	}

	/* (non-Javadoc)
	 * @see android.os.AsyncTask#onPostExecute(java.lang.Object)
	 */
	@Override
	protected void onPostExecute(String result) {
		// TODO Auto-generated method stub
		createJSON(result);
		
	}
	
}
